/* 
   circles - calculate identified circles statistics from CMB data (cosmic topology)

   Copyright (C) 2004 Boud Roukema

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

*/

#include <stdio.h>
#include <math.h>
#include <gsl/gsl_integration.h>

#include <gsl/gsl_errno.h>
#include <gsl/gsl_spline.h>

#include <stddef.h>
#include <errno.h>
#include <string.h>

#include "config.h"

#define CIRCLES_WANT_DEBUG 0

/* 
   USER PARAMETERS - BEGIN
*/

#define CIRCLES_INPUT_DIRECTORY "./"

/*
   USER PARAMETERS - END
   You probably should not change parameters below unless you're really
   sure you know what you're doing.
*/

/* main fortran program for circles calculations */

#define CIRC_F F77_FUNC_(circ_f,CIRC_F)
#ifdef __cplusplus
extern "C"  /* prevent C++ name mangling */
#endif
void CIRC_F(
	    char* input_directory, int *nlen_input_directory
	   );

/* plot statistics for dodecahedral hypothesis */

#define PDODEC F77_FUNC(pdodec,PDODEC)
#ifdef __cplusplus
extern "C"  /* prevent C++ name mangling */
#endif
void PDODEC(
	   );

#define PCIRCLES F77_FUNC(pcircles,PCIRCLES)
#ifdef __cplusplus
extern "C"  /* prevent C++ name mangling */
#endif
void PCIRCLES(
	    char* input_directory, int *nlen_input_directory
	   );

